/*
 * FILE				: button.c
 * DESCRIPTION		: This file is main files.
 * Author			: XiaomaGee@Gmail.com
 * Copyright		:
 *
 * History
 * --------------------
 * Rev	: 0.00
 * Date	: 03/05/2012
 *
 * create.
 * --------------------
 */

//---------------- Include files ------------------------//
#include "..\include\tft.h"
#include "..\include\gui_core.h"
#include "..\include\hardware.h"
#include "..\include\button.h"
#include "..\include\font.h"
#include <string.h>

#include <math.h>
#include <stdlib.h>
#include <string.h>

//---------------- Function Prototype -------------------//
static int draw(char **, int active);

//---------------- Variable -----------------------------//
BUTTON_T button = {
	.draw = draw,
};

//-----------------Function------------------------------//
/*
 * Name				: draw
 * Description		: ---
 * Author			: XiaomaGee.
 *
 * History
 * ----------------------
 * Rev	: 0.00
 * Date	: 03/08/2012
 *
 * create.
 * ----------------------
 */
static int
draw(char **p, int active)
{
	int i;
	STRING_T s;
	BOX_T b;
	RECT_T r;

	font._default.single_byte = &fixedsys;
	font._default.double_byte = &simsun16;

	for (i = 0; i < 5; i++) {
		if (p[i] != NULL) {
			b.startx = 0;
			b.starty = i * 48;
			b.endx = 72;
			b.endy = 47 + i * 48;
			b.attrib = (active == i ? BOX_RECESSED : BOX_RAISED) | BOX_CIRCULAR_RIGHT_UP | BOX_CIRCULAR_RIGHT_DOWN;
			b.color = (active == i ? COLOR_SYSTEM : COLOR_WINDOW_BACKGROUND);
			gui.box(&b);
		}else {
			r.x = 0;
			r.y = i * 48;
			r.width = 72;
			r.height = 48;

			r.fill_flag = 1;
			r.color = COLOR_WINDOW_BACKGROUND;
			gui.rect(&r);
		}

		if (p[i] == NULL) continue;

		if (strchr(p[i], '\n') == NULL) s.y = i * 48 + 16;
		else s.y = i * 48 + 6;
		s.x = 3;

		s.color = COLOR_BLACK;
		s.space.line = 5;
		s.space.word = 0;
		s.background_color = (active == i ? COLOR_SYSTEM : COLOR_WINDOW_BACKGROUND);
		s.inverse = NULL;
		font.printf(&s, "%s", p[i]);
	}

	return 0;
}
