/*
 * FILE				: systick.c
 * DESCRIPTION	    : This file is iCore usart driver.
 * Author		    : XiaomaGee@Gmail.com
 * Copyright		:
 *
 * History
 * --------------------
 * Rev	: 0.00
 * Date	: 03/05/2012
 *
 * create.
 * --------------------
 */

//---------------- Include files ------------------------//
#include "..\include\hardware.h"
#include "..\include\systick.h"
#include "..\include\nixietube.h"

#include <stdlib.h>
#include <string.h>

//---------------- Function Prototype -------------------//
static int initialize(void);
static int disable(void);

//---------------- Variable -----------------------------//
SYS_TICK_T systick = {
	.initialize = initialize,
	.counter = 0,
	.disable = disable
};

int event = 0;

//-----------------Function------------------------------//
/*
 * Name				: initialize
 * Description		: ---
 * Author			: XiaomaGee.
 *
 * History
 * ----------------------
 * Rev	: 0.00
 * Date	: 03/08/2012
 *
 * create.
 * ----------------------
 */
static int
initialize(void)
{
	SYSTICK->LOAD.B.RELOAD = 180000 / 2;  //9MHz main clock,90000 = 10ms
	SYSTICK->CTRL.B.ENABLE = 1;
	SYSTICK->CTRL.B.TICKINT = 1;
	SYSTICK->CTRL.B.CLKSOURCE = 0;     //hclk / 8 =9MHz CLK source
	return 0;
}

/*
 * Name				: disable
 * Description		: ---
 * Author			: XiaomaGee.
 *
 * History
 * ----------------------
 * Rev	: 0.00
 * Date	: 03/08/2012
 *
 * create.
 * ----------------------
 */
static int
disable(void)
{
	SYSTICK->CTRL.B.ENABLE = 0;

	return 0;
}

/*
 * Name				: SysTick_Handler
 * Description		: ---
 * Author			: XiaomaGee.
 *
 * History
 * ----------------------
 * Rev	: 0.00
 * Date	: 03/08/2012
 *
 * create.
 * ----------------------
 */
void SysTick_Handler(void)
{
	static int key_code_bak = 0;
	int key_code = 0;
	static int counter = 0;

	counter++;

	if (counter % 100 == 0) {
		systick.second_flag = 1;
	}
	if (counter % 10 == 0) {
		systick.msecond_100_flag = 1;
	}
	if (counter % 30 == 0) {
		systick.flash++;
	}
	if (counter % 50 == 0) {
		systick.msecond_500_flag = 1;
	}

	key_code = nix.scan();        //ɨ躯зصֵkey_code

	if (key_code == key_code_bak || key_code == 0) {
		key_code_bak = key_code;    //ĵǰֵͱֵȻߵǰֵΪ0key_codeֵkey_code_bak
		return;
	}
	event = key_code;
	key_code_bak = key_code;
}
