/*
 * FILE								: hardware.h
 * DESCRIPTION						: This file is iCore hardware file header.
 * Author							: XiaomaGee@Gmail.com
 * Copyright						:
 *
 * History
 * --------------------
 * Rev								: 0.00
 * Date								: 03/08/2012
 *
 * create.
 * --------------------
 */

//-----------------define-------------------------------//
#ifndef __hardware_h__
#define __hardware_h__

//-----------------Include files-------------------------//
#include "..\include\stm32f10x_reg.h"

//-------------- --- Define -----------------------------//
#define U_ID0   *((volatile unsigned long*)(0X1FFFF7E8))
#define U_ID1   *((volatile unsigned long*)(0X1FFFF7E8 + 4))
#define U_ID2   *((volatile unsigned long*)(0X1FFFF7E8 + 8))

#define FLASH_SIZE      *((volatile unsigned short*)(0X1FFFF7E0))

//led
#define LED_OUTPUT              GPIOC->CRH.B.MODE10 = 0X3; \
	GPIOC->CRH.B.CNF10 = 0
#define LED_ON                  GPIOC->BSRR.B.SETIO10 = 1
#define LED_OFF                 GPIOC->BSRR.B.CLRIO10 = 1

//tft
#define  TFTBL_OUTPUT           GPIOB->CRL.B.MODE6 = 0X3; \
	GPIOB->CRL.B.CNF6 = 0
#define TFTBL_ON                GPIOB->BSRR.B.SETIO6 = 1
#define TFTBL_OFF               GPIOB->BSRR.B.CLRIO6 = 1

#define  TFTRST_OUTPUT          GPIOE->CRL.B.MODE0 = 0X3; \
	GPIOE->CRL.B.CNF0 = 0
#define TFTRST_ON           GPIOE->BSRR.B.SETIO0 = 1
#define TFTRST_OFF          GPIOE->BSRR.B.CLRIO0 = 1

//nix
#define NIX_SEL0_OUTPUT         GPIOA->CRL.B.MODE5 = 0X3; \
	GPIOA->CRL.B.CNF5 = 0
#define NIX_SEL0_ON                     GPIOA->BSRR.B.SETIO5 = 1
#define NIX_SEL0_OFF            GPIOA->BSRR.B.CLRIO5 = 1

#define NIX_SEL1_OUTPUT         GPIOA->CRL.B.MODE6 = 0X3; \
	GPIOA->CRL.B.CNF6 = 0
#define NIX_SEL1_ON                     GPIOA->BSRR.B.SETIO6 = 1
#define NIX_SEL1_OFF            GPIOA->BSRR.B.CLRIO6 = 1

#define NIX_SEL2_OUTPUT         GPIOA->CRL.B.MODE7 = 0X3; \
	GPIOA->CRL.B.CNF7 = 0
#define NIX_SEL2_ON                     GPIOA->BSRR.B.SETIO7 = 1
#define NIX_SEL2_OFF            GPIOA->BSRR.B.CLRIO7 = 1

#define NIX_B0_OUTPUT           GPIOB->CRL.B.MODE1 = 0X3; \
	GPIOB->CRL.B.CNF1 = 0
#define NIX_B0_ON                       GPIOB->BSRR.B.SETIO1 = 1
#define NIX_B0_OFF                      GPIOB->BSRR.B.CLRIO1 = 1

#define NIX_B1_OUTPUT           GPIOB->CRL.B.MODE0 = 0X3; \
	GPIOB->CRL.B.CNF0 = 0
#define NIX_B1_ON                       GPIOB->BSRR.B.SETIO0 = 1
#define NIX_B1_OFF                      GPIOB->BSRR.B.CLRIO0 = 1

#define NIX_B2_OUTPUT           GPIOC->CRL.B.MODE5 = 0X3; \
	GPIOC->CRL.B.CNF5 = 0
#define NIX_B2_ON                       GPIOC->BSRR.B.SETIO5 = 1
#define NIX_B2_OFF                      GPIOC->BSRR.B.CLRIO5 = 1

//key
#define KEY_A_INPUT                 GPIOD->CRL.B.MODE2 = 0; \
	GPIOD->CRL.B.CNF2 = 0X1;

#define KEY_A                       GPIOD->IDR.B.IO2

#define KEY_B_INPUT                 GPIOD->CRL.B.MODE3 = 0; \
	GPIOD->CRL.B.CNF3 = 0X1;

#define KEY_B                       GPIOD->IDR.B.IO3

#define KEY_C_INPUT                 GPIOD->CRL.B.MODE6 = 0; \
	GPIOD->CRL.B.CNF6 = 0X1;

#define KEY_C                   GPIOD->IDR.B.IO6


#define initialize_key()        KEY_A_INPUT; \
	KEY_B_INPUT; \
	KEY_C_INPUT;

#define KEY_IN  GPIOC->IDR.B.IO2

//relay
#define RELAY_OUTPUT            GPIOC->CRL.B.MODE6 = 0X03; \
	GPIOC->CRL.B.CNF6 = 0
#define RELAY_ON                        GPIOC->BSRR.B.SETIO6 = 1
#define RELAY_OFF                       GPIOC->BSRR.B.CLRIO6 = 1

//swtich
#define SW0_IO_DATA                     GPIOB->IDR.B.IO2
#define SW1_IO_DATA                     GPIOB->IDR.B.IO10

//485
#define  RS485_OUTPUT           GPIOB->CRH.B.MODE11 = 0X3; \
	GPIOB->CRH.B.CNF11 = 0
#define RS485_T                         GPIOB->BSRR.B.SETIO11 = 1
#define RS485_R                         GPIOB->BSRR.B.CLRIO11 = 1

//DS1302
#define DS1302_IO_OUTPUT        GPIOC->CRL.B.MODE7 = 0X3; \
	GPIOC->CRL.B.CNF7 = 0
#define DS1302_IO_INPUT         GPIOC->CRL.B.MODE7 = 0;	\
	GPIOC->CRL.B.CNF7 = 0X1

#define DS1302_IO_ON            GPIOC->BSRR.B.SETIO7 = 1
#define DS1302_IO_OFF           GPIOC->BSRR.B.CLRIO7 = 1

#define DS1302_SCLK_OUTPUT      GPIOC->CRH.B.MODE9 = 0X3; \
	GPIOC->CRH.B.CNF9 = 0
#define DS1302_SCLK_ON          GPIOC->BSRR.B.SETIO9 = 1
#define DS1302_SCLK_OFF         GPIOC->BSRR.B.CLRIO9 = 1

#define DS1302_RST_OUTPUT       GPIOC->CRH.B.MODE8 = 0X3; \
	GPIOC->CRH.B.CNF8 = 0
#define DS1302_RST_ON           GPIOC->BSRR.B.SETIO8 = 1
#define DS1302_RST_OFF          GPIOC->BSRR.B.CLRIO8 = 1

#define DS1302_IO_DATA          GPIOC->IDR.B.IO7

//opc
#define OPC_OUT_OUTPUT          GPIOC->CRL.B.MODE0 = 0X3; \
	GPIOC->CRL.B.CNF0 = 0

#define OPC_OUT_ON                      GPIOC->BSRR.B.SETIO0 = 1
#define OPC_OUT_OFF                     GPIOC->BSRR.B.CLRIO0 = 1

#define OPC_IN                          GPIOC->IDR.B.IO13

#define VREF    2.5

#endif //__hardware_h__
















