/*------------------------------------------------------
   FILE NAME   : i2c.h
   DESCRIPTION : i2c driver file header
   VERSION     : 0.0.0 (C)XiaomaGee
   AUTHOR      : XiaomaGee
   CREATE DATE : 2010-6-3
   MODIFY DATE :
   LOGS        :-\
   --------------------------------------------------------*/
#ifndef __i2c_h__
#define __i2c_h__

//-----------------Include files-------------------------//
#define SCL_OUTPUT      GPIOB->CRH.B.MODE8 = 0X3; \
	GPIOB->CRH.B.CNF8 = 0X1

#define SDA_OUTPUT      GPIOC->CRH.B.MODE11 = 0X3; \
	GPIOC->CRH.B.CNF11 = 0X1

#define SDA_INPUT       GPIOC->CRH.B.MODE11 = 0; \
	GPIOC->CRH.B.CNF11 = 0X1

#define SCL_ON          GPIOB->BSRR.B.SETIO8 = 1
#define SCL_OFF         GPIOB->BSRR.B.CLRIO8 = 1


#define SDA_ON          GPIOC->BSRR.B.SETIO11 = 1
#define SDA_OFF         GPIOC->BSRR.B.CLRIO11 = 1

#define SDA_DATA        GPIOC->IDR.B.IO11




//----------------- Typedef------------------------------//
typedef  struct {
	int (* initialize)(void);
	unsigned char (* read)(void);
	int (* write)(unsigned char data);
	int (* start)(void);
	int (* stop)(void);
	int (* check_ack)(void);
	int (* ack)(char);
	int ack_flag;
	int (* read_nbyte)(unsigned char, unsigned char, unsigned char *, unsigned char);
	int (* write_nbyte)(unsigned char, unsigned char, unsigned char *, unsigned char);
}MY_I2C_T;

//----------------- Extern ------------------------------//

extern MY_I2C_T i2c;

#endif //__i2c_h__
