/*
 * FILE				: tft.h
 * DESCRIPTION		: This file is main files.
 * Author			: XiaomaGee@Gmail.com
 * Copyright		:
 *
 * History
 * --------------------
 * Rev	: 0.00
 * Date	: 03/05/2012
 *
 * create.
 * --------------------
 */

//-----------------Define--------------------------------//
#ifndef __TFT_H__
#define __TFT_H__

#define LCD_COMMAND     *((volatile unsigned short int*)(0x60000000 + (1 << 23)))

#define LCD_DATA        *((volatile unsigned short int*)(0x60020000 + (1 << 23)))

#define LCD_XSIZE       320
#define LCD_YSIZE       240

#define DISPLAY_ON      1
#define DISPLAY_OFF     0

#define CSRMODE_H       0
#define CSRMODE_V       1

#define lcd_ctl(x)      tft.lcd_ctl(x)

//------------------- Typedef --------------------------//
typedef  struct {
	int (* initialize)(void);
	int (* cls)(unsigned short int /*color*/);
	int (* set_point)(unsigned short int /*x*/, unsigned short int /*y*/, unsigned short int /*color*/);
	unsigned short int (* get_point)(unsigned short int /*x*/, unsigned short int /*y*/);
	int (* write_command)(unsigned short int /*command*/);
	int (* write_data)(unsigned short int /*data*/);
	int (* lcd_ctl)(unsigned short int /*ctl_w*/);
}TFT_T;

typedef union {
	struct {
		unsigned short int dispen : 1;
		unsigned short int tmode : 5;
		unsigned short int csrmode : 1;
		unsigned short int reserve1 : 8;
		unsigned short int LED : 1;
	}b;
	unsigned short int w;
}LCD_CTL_T;

//----------------- Extern ------------------------------//
extern TFT_T tft;
extern LCD_CTL_T lcd_ctl;

extern void lcd_data(unsigned short int);
extern void lcd_csrx(unsigned short int);
extern void lcd_csry(unsigned short int);
extern unsigned short int get_data(void);

#endif //__TFT24_H__
