/*
 * FILE				: main.c
 * DESCRIPTION		: This file is main files.
 * Author			: XiaomaGee@Gmail.com
 * Copyright		:
 *
 * History
 * --------------------
 * Rev	: 0.00
 * Date	: 03/05/2012
 *
 * create.
 * --------------------
 */

//-----------------Include files-------------------------//
#include "..\include\nvic.h"
#include "..\include\rcc.h"
#include "..\include\fsmc.h"
#include "..\include\flash.h"
#include "..\include\spi.h"
#include "..\include\tft.h"
#include "..\include\systick.h"
#include "..\fatfs\ff.h"
#include "..\include\gui_core.h"
#include "..\include\tab.h"
#include "..\include\color.h"
#include "..\include\font.h"
#include "..\include\button.h"

#include "..\include\usb_mass.h"
#include "..\include\key.h"
#include "..\include\fpga.h"

#include "..\include\nixietube.h"
#include "..\include\bmp.h"

#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <stdio.h>

//-----------------Function Prototype--------------------//
static int  virtual_u(void);
static int  capture(void);

//---------------- Variable -----------------------------//

//-----------------Function------------------------------//
/*
 * Name				: SystemInit
 * Description		: ---
 * Author			: XiaomaGee.
 *
 * History
 * ----------------------
 * Rev				: 0.00
 * Date				: 03/05/2012
 *
 * create.
 * ----------------------
 */

void SystemInit(void)
{
}

/*
 * Name				: initialize
 * Description		: ---
 * Author			: XiaomaGee.
 *
 * History
 * ----------------------
 * Rev	: 0.00
 * Date	: 03/05/2012
 *
 * create.
 * ----------------------
 */
static int initialize(void)
{
	int i;

	for (i = 0; i < 100000; i++) ;

	nvic.initialize();
	rcc.initialize();
	spi1.initialize();
	fsmc.initialize();
	tft.initialize();
	initialize_key();

	tft.cls(COLOR_WINDOW_BACKGROUND);
	TFTBL_OFF;
	font.initialize();

	virtual_u();

	nix.initialize();
	systick.initialize();

	return 0;
}
/*
 * Name				: main
 * Description		: ---
 * Author			: XiaomaGee.
 *
 * History
 * ----------------------
 * Rev	: 0.00
 * Date	: 03/05/2012
 *
 * create.
 * ----------------------
 */
int main(void)
{
	FATFS fatfs;
	TAB_T t;
	char * main_tab[] = {
		"FSMC д FPGA", NULL
	};
	static int counter = 0;
	unsigned int i, j;
	unsigned int dat;
	STRING_T s;
	int success = 0;
	int errors = 0;
	PROCESSBAR_T p;

	initialize();

	f_mount(0, &fatfs);

	t.sfont = &fixedsys;
	t.dfont = &simsun16;
	t.x = 15;
	t.y = 11;
	t.title = main_tab;
	t.active = 0;
	t.height = 216;
	t.width = 290;
	tab(&t);

	for (j = 0; j < 300; j++) {
		//д
		for (i = 0; i < 65536; i++) {
			fpga_write(7, i);

			dat = fpga_read(0);

			if ((dat + i) != 65535) {
				errors++;
			}else success++;
		}
 		//ҺӡϢ
		font._default.single_byte = &fixedsys;
		font._default.double_byte = &simsun16;

		s.x = 33;
		s.y = 60;
		s.space.line = 4;
		s.space.word = 0;
		s.color = COLOR_BLUE;
		s.background_color = COLOR_WINDOW_BACKGROUND;
		s.inverse = NULL;

		font.printf(&s, " %d ֲԣÿ 65535 ζд\n", 1 + counter++);
		font.printf(&s, "%08d ȷ\n%08d ݴ\n", success, errors);

		capture();

		p.x = 30;
		p.y = 180;
		p.width = 260;
		p.percentage = (j + 1) / 3;
		p.color = COLOR_BLUE;
		gui.processbar(&p);
	}
	font.printf(&s, "%d β\n", errors + success);
	if (errors) {
		s.color = COLOR_RED;
		font.printf(&s, "ʧ!");
	}else {
		s.color = COLOR_BLUE;
		font.printf(&s, "Գɹ!");
	}

	while (1) capture();
}

/*
 * Name				: virtual_u
 * Description		: ---
 * Author			: XiaomaGee.
 *
 * History
 * -----------------------
 * Rev	: 0.00
 * Date	: 03/05/2012
 *
 * create.
 * ----------------------
 */
static int
virtual_u(void)
{
	STRING_T s;

	KEY_A_INPUT;

	if (KEY_A) return 0;
	tft.cls(COLOR_BLACK);
	usb_mass.initialize();

	font._default.single_byte = &fixedsys;

	//MESSAGE
	s.x = 10;
	s.y = 10;
	s.space.line = 2;
	s.space.word = 0;
	s.color = COLOR_SYSTEM;
	s.background_color = COLOR_BLACK;
	s.inverse = NULL;
	font.printf(&s, "virtual U ........");

	while (1) ;
}

/*
 * Name				: capture
 * Description		: ---
 * Author			: XiaomaGee.
 *
 * History
 * -----------------------
 * Rev	: 0.00
 * Date	: 03/05/2012
 *
 * create.
 * ----------------------
 */
static int
capture(void)
{
	STRING_T s;

	if (KEY_B == 0 && KEY_C == 0) {
		bmp.capture();

		tft.cls(COLOR_BLACK);
		font._default.single_byte = &fixedsys;
		//MESSAGE
		s.x = 80;
		s.y = 100;
		s.space.line = 2;
		s.space.word = 0;
		s.color = COLOR_SYSTEM;
		s.background_color = COLOR_BLACK;
		s.inverse = NULL;
		font.printf(&s, "capture success!!!!");

		systick.disable();

		usb_mass.initialize();

		while (1) ;
	}

	return 0;
}
